; **********************************
; * Mapping File for 6x5 Videowall *
; **********************************

;Array is referenced in sequence
;Using ROW ID = A-E, COLUMN ID = 1-6
;Eg. Top Left     Monitor is A1 (Unit UA1)
;    bottom Right Monitor is E6 (Unit UE6)

; Processor Unit ID = 0
; Output Channels [ C = Col, R = Row ]
;   C1  C2  C3  C4  C5  C6
;RA  1   2   3  --  --  --
;RB  4   5   6  --  --  --
;RC  7   8   9  --  --  --
;RD 10  11  12  --  --  --
;RE 13  14  15  --  --  --

; Processor Unit ID = 1
; Output Channels [ C = Col, R = Row ]
;   C1  C2  C3  C4  C5  C6
;RA --  --  --   1   2   3
;RB --  --  --   4   5   6
;RC --  --  --   7   8   9
;RD --  --  --  10  11  12
;RE --  --  --  13  14  15

; Define Unit ID for Addressed Outputs
DEFINE UA1 = UNIT 0
DEFINE UA2 = UNIT 0
DEFINE UA3 = UNIT 0
DEFINE UA4 = UNIT 1
DEFINE UA5 = UNIT 1
DEFINE UA6 = UNIT 1

DEFINE UB1 = UNIT 0
DEFINE UB2 = UNIT 0
DEFINE UB3 = UNIT 0
DEFINE UB4 = UNIT 1
DEFINE UB5 = UNIT 1
DEFINE UB6 = UNIT 1

DEFINE UC1 = UNIT 0
DEFINE UC2 = UNIT 0
DEFINE UC3 = UNIT 0
DEFINE UC4 = UNIT 1
DEFINE UC5 = UNIT 1
DEFINE UC6 = UNIT 1

DEFINE UD1 = UNIT 0
DEFINE UD2 = UNIT 0
DEFINE UD3 = UNIT 0
DEFINE UD4 = UNIT 1
DEFINE UD5 = UNIT 1
DEFINE UD6 = UNIT 1

DEFINE UE1 = UNIT 0
DEFINE UE2 = UNIT 0
DEFINE UE3 = UNIT 0
DEFINE UE4 = UNIT 1
DEFINE UE5 = UNIT 1
DEFINE UE6 = UNIT 1

; Assign Processor Outputs to each Array ID
DEFINE A1 = 0
DEFINE A2 = 1
DEFINE A3 = 2
DEFINE A4 = 0
DEFINE A5 = 1
DEFINE A6 = 2

DEFINE B1 = 3
DEFINE B2 = 4
DEFINE B3 = 5
DEFINE B4 = 3
DEFINE B5 = 4
DEFINE B6 = 5

DEFINE C1 = 6
DEFINE C2 = 7
DEFINE C3 = 8
DEFINE C4 = 6
DEFINE C5 = 7
DEFINE C6 = 8

DEFINE D1 = 9
DEFINE D2 = 10
DEFINE D3 = 11
DEFINE D4 = 9
DEFINE D5 = 10
DEFINE D6 = 11

DEFINE E1 = 12
DEFINE E2 = 13
DEFINE E3 = 14
DEFINE E4 = 12
DEFINE E5 = 13
DEFINE E6 = 14
