; **********************************
; * Mapping File for 7x7 Videowall *
; **********************************

;Array is referenced in sequence
;Using ROW ID = A-G, COLUMN ID = 1-7
;Eg. Top Left     Monitor is A1 (Unit UA1)
;    bottom Right Monitor is G7 (Unit UG7)

; Processor Unit ID = 0
; Output Channels [ C = Col, R = Row ]
;   C1  C2  C3  C4  C5  C6  C7
;RA  1   2   3   4  --  --  --
;RB  5   6   7   8  --  --  --
;RC  9  10  11  12  --  --  --
;RD 13  14  15  16  --  --  --
;RE 17  18  19  20  --  --  --
;RF 21  22  23  24  --  --  --
;RG --  --  --  --  --  --  --

; Processor Unit ID = 1
; Output Channels [ C = Col, R = Row ]
;   C1  C2  C3  C4  C5  C6  C7
;RA --  --  --  --   1   2   3
;RB --  --  --  --   4   5   6
;RC --  --  --  --   7   8   9
;RD --  --  --  --  10  11  12
;RE --  --  --  --  13  14  15
;RF --  --  --  --  16  17  18
;RG 19  20  21  22  23  24  25


; Define Unit ID for Addressed Outputs
DEFINE UA1 = UNIT 0
DEFINE UA2 = UNIT 0
DEFINE UA3 = UNIT 0
DEFINE UA4 = UNIT 0
DEFINE UA5 = UNIT 1
DEFINE UA6 = UNIT 1
DEFINE UA7 = UNIT 1

DEFINE UB1 = UNIT 0
DEFINE UB2 = UNIT 0
DEFINE UB3 = UNIT 0
DEFINE UB4 = UNIT 0
DEFINE UB5 = UNIT 1
DEFINE UB6 = UNIT 1
DEFINE UB7 = UNIT 1

DEFINE UC1 = UNIT 0
DEFINE UC2 = UNIT 0
DEFINE UC3 = UNIT 0
DEFINE UC4 = UNIT 0
DEFINE UC5 = UNIT 1
DEFINE UC6 = UNIT 1
DEFINE UC7 = UNIT 1

DEFINE UD1 = UNIT 0
DEFINE UD2 = UNIT 0
DEFINE UD3 = UNIT 0
DEFINE UD4 = UNIT 0
DEFINE UD5 = UNIT 1
DEFINE UD6 = UNIT 1
DEFINE UD7 = UNIT 1

DEFINE UE1 = UNIT 0
DEFINE UE2 = UNIT 0
DEFINE UE3 = UNIT 0
DEFINE UE4 = UNIT 0
DEFINE UE5 = UNIT 1
DEFINE UE6 = UNIT 1
DEFINE UE7 = UNIT 1

DEFINE UF1 = UNIT 0
DEFINE UF2 = UNIT 0
DEFINE UF3 = UNIT 0
DEFINE UF4 = UNIT 0
DEFINE UF5 = UNIT 1
DEFINE UF6 = UNIT 1
DEFINE UF7 = UNIT 1

DEFINE UG1 = UNIT 1
DEFINE UG2 = UNIT 1
DEFINE UG3 = UNIT 1
DEFINE UG4 = UNIT 1
DEFINE UG5 = UNIT 1
DEFINE UG6 = UNIT 1
DEFINE UG7 = UNIT 1

; Assign Processor Outputs to each Array ID
DEFINE A1 = 0
DEFINE A2 = 1
DEFINE A3 = 2
DEFINE A4 = 3
DEFINE A5 = 0
DEFINE A6 = 1
DEFINE A7 = 2

DEFINE B1 = 4
DEFINE B2 = 5
DEFINE B3 = 6
DEFINE B4 = 7
DEFINE B5 = 3
DEFINE B6 = 4
DEFINE B7 = 5

DEFINE C1 = 8
DEFINE C2 = 9
DEFINE C3 = 10
DEFINE C4 = 11
DEFINE C5 = 6
DEFINE C6 = 7
DEFINE C7 = 8

DEFINE D1 = 12
DEFINE D2 = 13
DEFINE D3 = 14
DEFINE D4 = 15
DEFINE D5 = 9
DEFINE D6 = 10
DEFINE D7 = 11

DEFINE E1 = 16
DEFINE E2 = 17
DEFINE E3 = 18
DEFINE E4 = 19
DEFINE E5 = 12
DEFINE E6 = 13
DEFINE E7 = 14

DEFINE F1 = 20
DEFINE F2 = 21
DEFINE F3 = 22
DEFINE F4 = 23
DEFINE F5 = 15
DEFINE F6 = 16
DEFINE F7 = 17

DEFINE G1 = 18
DEFINE G2 = 19
DEFINE G3 = 20
DEFINE G4 = 21
DEFINE G5 = 22
DEFINE G6 = 23
DEFINE G7 = 24
