; ************************************************************
; *                                                          *
; *  Standard Include File for BRICK-2 Video Wall Processor  *
; *                                                          *
; ************************************************************

; Jan-08 Version 1.6      V2.xx and V3.xx Firmware aligned

EXIT IF DEFINED FN_RESET  ; In case this file is called twice

DEFINE _DEVICE      7     ; Target is Brick processor

; Change UNIT ID on the fly
DEFINE UNIT SET _UNIT ?1

DEFINE FN_RESET        0  ;  Reset application
DEFINE FN_SBAUD        1  ;  Set comms baud rate
DEFINE FN_SETDEF       2  ;  Set defaults
DEFINE FN_GETCFG       3  ;  Get config data (DIP SW etc..)
DEFINE FN_GETRLS       4  ;  Get S/W release info
DEFINE FN_KILL         5  ;  Clear queue & background task
DEFINE FN_SETID        6  ;  Set unit ID
DEFINE FN_GO           7  ;  Go command
DEFINE FN_HOLD         8  ;  Hold command
DEFINE FN_IMM          9  ;  Make next command immediate
DEFINE FN_SHOWSTAT    10  ;  Show global status
DEFINE FN_GETBKGND    11  ;  Get background task status
DEFINE FN_WRIR        12  ;  Write to IR chip
DEFINE FN_RDI2C       13  ;  Read directly from I2C register
DEFINE FN_WRI2C       14  ;  Write directly to I2C reg(s)
DEFINE FN_MONF        15  ;  Monitor functions (Factory Use Only)
DEFINE FN_DGTINP      16  ;  Select - Composite/S-video/RGB
DEFINE FN_DGTBRT      17  ;  Brightness
DEFINE FN_DGTCNT      18  ;  Contrast
DEFINE FN_DGTSAT      19  ;  Saturation
DEFINE FN_DGTHUE      20  ;  Hue (NTSC only = set to 128 for PAL)
DEFINE FN_DGTSYS      21  ;  Set Decoder video system = PAL/NTSC/SECAM
DEFINE FN_DGTSAVE     24  ;  Save digitiser settings in FLASH
DEFINE FN_DGTREAD     25  ;  Read current Digitiser settings
DEFINE FN_PYRMX       26  ;  Pyramid X offset
DEFINE FN_PYRMY       27  ;  Pyramid y offset
DEFINE FN_FLGMODE     28  ;  Flag mode OR/XOR
DEFINE FN_CHARMODE    29  ;  Select character I/P mode
DEFINE FN_ENCSYS      30  ;  Set Encoder Video system COMP/S-Video
DEFINE FN_RDMONST     31  ;  Read Monitor State
DEFINE FN_MAP         32  ;  Map monitors to CH ID
DEFINE FN_ENCLVL      33  ;  Set black level Pedestal On/Off
DEFINE FN_ENCSAVE     34  ;  Save Encoder settings
DEFINE FN_ENCREAD     35  ;  Read current Encoder settings
DEFINE FN_ALGNCOL     36  ;  Set column alignment +/- 32
DEFINE FN_ALGNROW     37  ;  Set row alignment +/- 32
DEFINE FN_ALGNSAVE    38  ;  Save aligment
DEFINE FN_ALGNREAD    39  ;  Read current alignment values
DEFINE FN_SPLIT       40  ;  Set global split
DEFINE FN_SETWASH     41  ;  Set wash: mon R,G,B <rate>
DEFINE FN_DSPMODE     42  ;  Monitor display mode VIDEO/MAG/WASH/BARS
DEFINE FN_INTOFF      43  ;  Set interlace offset
DEFINE FN_FREEZE      44  ;  Freeze Off/odd/even/Frame
DEFINE FN_STROBE      45  ;  Strobe on/off
DEFINE FN_TXTMODE     46  ;  Interlace mode on/off
DEFINE FN_SELMON      47  ;  Select monitors (flags - 1..25)
DEFINE FN_DGTVCR      48  ;
DEFINE FN_ENCVCR      49  ;  
DEFINE FN_VDMA        50  ;  Temp VDMA offsets
DEFINE FN_TESTPAT     51  ;  Test pattern
DEFINE FN_WIPE        52  ;  Wipe A/B/Wash up/down/left/right
DEFINE FN_PIXEL       53  ;  Pixellation

; Bank 0=Horizontal Flags 1=Vertical Flags
; Offset = 0..size of bank-1
; Count  = 1..size of bank (-1 = all)
; dir 1= R->L, -1 = L->R
; Flag 6 LSBs = flag state.
DEFINE FN_WRFLAG      54  ;  Write to flags bank,offset,count,dir,flags

DEFINE FN_TBCALT      55  ; TBC Alternate Field
DEFINE FN_TBCPOS      56  ; TBC Position
DEFINE FN_TBCENABLE   57  ; TBC Enable
DEFINE FN_TBCMODE     58  ; TBC Mode
DEFINE FN_TBCFREEZE   59  ; TBC Freeze
DEFINE FN_SFIRST      60  ; Search first for filespec
DEFINE FN_SNEXT       61  ; Search for next match of filespec
DEFINE FN_FOPEN       62  ; Open file mode,<n>:name
DEFINE FN_FREAD       63  ; Read Nx bytes from open file
DEFINE FN_FWRITE      64  ; Write Nx bytes to open file
DEFINE FN_FCLOSE      65  ; Close open file
DEFINE FN_ERASE       66  ; Erase file <n>:name
DEFINE FN_PREP        67  ; Erase/Format FLASH
DEFINE FN_FREESP      68  ; Get used/free FLASH space
DEFINE FN_RESTORE     69  ; Recover wasted FLASH space
DEFINE FN_FRENAME     70  ; Rename flash file
DEFINE FN_FILTER      71  ; Filter interpolation setting
DEFINE FN_MONADJ      72  ; Fine monitor ajustment (<mon> <0x6c> <0x6d>)
DEFINE FN_READADJ     73  ; Read monitor fine adjustment
DEFINE FN_SEQIRN      75  ; Run sequence from IR key N
DEFINE FN_SEQERR      76  ; Get sequence termination data
DEFINE FN_RUNSEQ      77  ; Run named sequence file
DEFINE FN_READSEQ     78  ; Get executing sequence filename
DEFINE FN_STOPSEQ     79  ; Cancel executing sequence
DEFINE FN_INITGX      80  ; Initialise graphics subsystem
DEFINE FN_SELPAGE     81  ; Select graphics page
DEFINE FN_SELFONT     82  ; Select Font "name" 0
DEFINE FN_PTEXT       83  ; Print text string "string" 0
DEFINE FN_LINETO      84  ; Lineto x,y
DEFINE FN_MOVETO      85  ; Moveto x,y
DEFINE FN_LINER       86  ; Line relative to x,y
DEFINE FN_MOVER       87  ; Move relative to x,y
DEFINE FN_FILL        88  ; Fill current page
DEFINE FN_COLOUR      89  ; Current drawing colour
DEFINE FN_PLTBMP      90  ; plot bmp
DEFINE FN_ELLIPSE     91  ; plot ellipse
DEFINE FN_RECT        92  ; plot rectangle
DEFINE FN_YUVCOL      93  ; Set colour from YUV
DEFINE FN_CLRSCN      94  ; Clear screen
DEFINE FN_PLTYUV      95  ; Plot string of YUV Quads
DEFINE FN_EFFECT      96  ; Select Video Effect (Solarise, Etc.)
DEFINE FN_SLIMIT      98  ; Screen limits x1,x2,y1,y2
DEFINE FN_BLIMIT      99  ; Bounce limits x1,x2,y1,y2,rate
DEFINE FN_ASYMSPLIT  100  ; Asym. split
DEFINE FN_ZOOM       101  ; Zoom in x,y
DEFINE FN_IRIS       102  ; IRIS x,y,dx,dy
DEFINE FN_BOUNCE     103  ; Bounce
DEFINE FN_MINIFY     104  ; Minify n
DEFINE FN_CLRCYCLE   105  ; Cycle Wash Rs,Gs,Bs
DEFINE FN_MIRROR     106  ; Mirror x2
DEFINE FN_BUSBSRC    108  ; Select source to be output on Output Bus-B
DEFINE FN_XFADE      109  ; Crossfade Video-1 and Video-2 on Input Bus-A

; *** Macro Definitions ***

DEFINE TX SEND _DEVICE _UNIT

DEFINE ALL       -1
DEFINE *         -1
DEFINE CVIDEO     0
DEFINE SVIDEO     1
DEFINE VIDEO      0
DEFINE A          0
DEFINE B          1
DEFINE WASH       2
DEFINE BARS       3
DEFINE OFF        0
DEFINE INSTANT    0
DEFINE ON         1
DEFINE EVEN       1
DEFINE ODD        2
DEFINE FULL       0
DEFINE BOTH       3
DEFINE PIP        1
DEFINE WALL       2
DEFINE RGB_OUT    0
DEFINE PAL_OUT    1
DEFINE NTSC_OUT   2
DEFINE SECAM_OUT  3
DEFINE NONE_OUT   5
DEFINE RIGHT      0
DEFINE LEFT       1
DEFINE DOWN       2
DEFINE UP         3
DEFINE IN         4
DEFINE OUT        5
DEFINE HORIZONTAL 0
DEFINE VERTICAL   1


; *******************************************
; *                                         *
; *   FRIENDLY FORMAT COMMAND DEFINITIONS   *
; *                                         *
; *******************************************

; Trigger a Queued Command (see Hold command)
DEFINE GO           TX FN_GO

; Kill Dynamic Application (Bounce, Wash Cycle, Etc)
DEFINE KILL         TX FN_KILL

; Queue Command for execution on receipt of a GO command
DEFINE HOLD         TX FN_HOLD

; Mark a command as immediate, regardless of it's immediate attribute
DEFINE IMMEDIATE    TX FN_IMM

; Select Video Input (Source, Composite/S-Video)
DEFINE VIDEOINPUT   TX FN_DGTINP ?1 ?2

; Set Brightness (Source, Value)
DEFINE BRIGHTNESS   TX FN_DGTBRT ?1 ?2

; Set Contrast (Source, Value)
DEFINE CONTRAST     TX FN_DGTCNT ?1 ?2

; Set Saturation (Source, Value)
DEFINE SATURATION   TX FN_DGTSAT ?1 ?2

; Set Hue (Source, Value)
DEFINE HUE          TX FN_DGTHUE ?1 ?2

; Set Video System (Source, PAL/NTSC/SECAM)
DEFINE VIDEOSYSTEM  TX FN_DGTSYS ?1 ?2

; Save Video Input Settings
DEFINE SAVEINPUT    TX FN_DGTSAVE

; Read Video Input Settings
DEFINE READINPUT    TX FN_DGTREAD

; Set Video I/O System (PAL/NTSC/SECAM)
DEFINE DISPLAYMODE  TX FN_ENCSYS ?1

; Draw Test Pattern (Page 0/1, Current_Split/Split=N)
DEFINE TESTPATTERN  TX FN_TESTPAT ?1 ?2

; TBC Mode = Alternate Field (ON/OFF)
DEFINE TBCALT       TX FN_TBCALT ?1

; TBC Window Position (TL=0/TR=1/BL=2/BR=3)
DEFINE TBCWINDOW    TX FN_TBCPOS ?1

; TBC Window Enabled (ON/OFF)
DEFINE TBCENABLE    TX FN_TBCENABLE ?1

; TBC Size (0=Full,1=PiP,2=BRICKWALL,3=Reserved)
DEFINE TBCMODE      TX FN_TBCMODE ?1

; TBC Freeze (ON/OFF)
DEFINE TBCFREEZE    TX FN_TBCFREEZE ?1

; Set global split (See also Letterbox)
DEFINE SETSPLIT     TX FN_SPLIT ?1

; Set asymmetric split
DEFINE ASPLIT       TX FN_ASYMSPLIT ?1 ?2

; Get Firmware Version
DEFINE FWVERSION    TX FN_GETRLS

; Get Hardware Configuration/Version
DEFINE HWCONFIG     TX FN_GETCFG

; Select Letterbox Mode (Split, Y-Offset, X-Offset)
; This is really a Split command
; Y-offset=1: Shift Up Half Screen, X-offset=1: Shift Left Half Screen
DEFINE LETTERBOX    TX FN_SPLIT ?1 ?2 ?3

; Set Output Wash Colour, Monitor,R,G,B
; Range of R/G/B = 0-255 (0 = Minimum, 255 = Maximum)
DEFINE WASHCOLOUR   TX FN_SETWASH ?1 ?2 ?3 ?4 0

; Select Display Output Mode: Monitor,MAG/WASH
DEFINE DISPLAY      TX FN_DSPMODE ?1 ?2

; Freeze Off/odd/even/Frame
DEFINE FREEZE       TX FN_FREEZE ?1

; Initialise graphics subsystem
DEFINE INITGX       TX FN_INITGX

; Select graphics page <n>
DEFINE PAGE         TX FN_SELPAGE ?1

; Draw filled rectangle
DEFINE RECTANGLE    TX FN_RECT &?1 &?2

; Select Font "FONT"
DEFINE FONT         TX FN_SELFONT ?1 ?2 0

; Print text string "string"
DEFINE PRINT        TX FN_PTEXT ?1 0

; Draw line absolute x,y
DEFINE LINE         TX FN_LINETO &?1 &?2

; Move cursor absolute x,y
DEFINE CURSOR       TX FN_MOVETO &?1 &?2

; Move relative dx,dy
DEFINE RCURSOR      TX FN_MOVER  &?1 &?2

; Line relative dx,dy
DEFINE RLINE        TX FN_LINER  &?1 &?2

; Fill current page
DEFINE FILL         TX FN_FILL

; Set Graphics Drawing Colour (RGB Colour Space) R,G,B
; Range of R/G/B = 0-255 (0 = Minimum, 255 = Maximum)
DEFINE COLOUR       TX FN_COLOUR ?1 ?2 ?3

; Set Graphics Drawing Colour (YUV Colour Space) Y,U,V
; Range of Y/U/V = 0-255 (0 = Minimum, 255 = Maximum)
DEFINE YUVCOLOUR    TX FN_YUVCOL ?1 ?2 ?3

; Plot Two-colour Bitmap from file (Sector/"file.bmp")
DEFINE BITMAP       TX FN_PLTBMP ?1 ?2 0

; Draw an ellipse in current graphics colour
DEFINE ELLIPSE      TX FN_ELLIPSE &?1 &?2

; Bounce zoomed in image.
DEFINE BOUNCE       TX FN_BOUNCE ?1

; Set screen video limits
DEFINE SLIMIT       TX FN_SLIMIT &?1 &?2 &?3 &?4

; Set bounce limits x1,x2,y1,y2
DEFINE BLIMIT       TX FN_BLIMIT &?1 &?3 &?2 &?4 1

; PAN Image
DEFINE PAN          TX FN_PAN ?1 ?2

; ZOOM Image
DEFINE ZOOM         TX FN_ZOOM &?1 &?2

; IRIS Image
DEFINE IRIS         TX FN_IRIS &?1 &?2 &?3 &?4

; Set text mode on/off
; Interlace ON = 1, Interlace OFF = 0
DEFINE TEXTMODE     TX FN_TXTMODE ?1

; Set text mode on/off
; Interlace ON = 1, Interlace OFF = 0
DEFINE INTERLACE    TX FN_TXTMODE ?1

; Interlace Offset (Split, +/-Value)
DEFINE IOFFSET      TX FN_INTOFF ?1

; Wipe: direction,source,rate
DEFINE WIPE         TX FN_WIPE ?1 ?2 ?3

; Source select
DEFINE SOURCE       TX FN_WIPE LEFT ?1 0

; Strobe
DEFINE STROBE       TX FN_STROBE ?1

; Minify image
DEFINE MINIFY       TX FN_MINIFY ?1

; Set Big Pixels
DEFINE PIXELLATE    TX FN_PIXEL ?1 ?2

; Save Output Settings
DEFINE SAVEOUTPUT   TX FN_ENCSAVE

; Read Output Settings
DEFINE READOUTPUT   TX FN_ENCREAD

; Shift Output Horizontal (Monitor COLUMN, +/-Value)
DEFINE ALIGNH       TX FN_ALGNCOL ?1 ?2

; Shift Output Vertical (Monitor ROW, +/-Value)
DEFINE ALIGNV       TX FN_ALGNROW ?1 ?2

; Shift Monitor (Monitor X +/-Value, Y +/-Value)
DEFINE ALIGNM       TX FN_MONADJ ?1 ?2 ?3

; Save Alignment Settings
DEFINE SAVEALIGN    TX FN_ALGNSAVE

; Read Alignment Settings
DEFINE READALIGN    TX FN_ALGNREAD

; Initialise Scree Values for Borders Etc.
DEFINE CLEARSCREEN  TX FN_CLRSCN

; Video Effect = Normal
DEFINE NORMAL       TX FN_EFFECT 0

; Video Effect = Solarise
DEFINE SOLARISE     TX FN_EFFECT 1

; Video Effect = Negative
DEFINE NEGATIVE     TX FN_EFFECT 2

; Video Effect = Dazzle
DEFINE DAZZLE       TX FN_EFFECT 4

; Video Effect = Vertical Hatch
DEFINE VHATCH       TX FN_EFFECT 3

; Video Effect = Horizontal Hatch
DEFINE HHATCH       TX FN_EFFECT 5

; Video Effect = Cross Hatch
DEFINE XHATCH       TX FN_EFFECT 6

; Video Effect = Dot Hatch
DEFINE DHATCH       TX FN_EFFECT 7

; Cycle WASH Colour [Monitor,+/-Rs,+/-Gs,+/-Bs ]
DEFINE WASHCYCLE    TX FN_CLRCYCLE &?1 &?2 &?3

; Single Character Input Selects IR Sequence [ 0N/OFF ]
DEFINE IRCHARACTER  TX FN_CHARMODE ?1

; Colour cycle (+/-R speed, +/-G speed, +/- B speed)
DEFINE CLRCYCLE     TX FN_CLRCYCLE &?1 &?2 &?3

; Select source to be output on Video Bus-B
; 0 = Video Input-1, 1 = Video Input-2
DEFINE BUSBSRC      TX FN_BUSBSRC ?1

; Map Monitor, MONITOR X Y
DEFINE MAP          TX FN_MAP ?1 ?2 ?3

